//---------------------------------------------------------------------------

#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include "D:\Projects\Components\ShellControls\shellctrls.h"
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>
#include <IniFiles.hpp>
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
    TOpenDialog *OpenDialog;
    TSaveDialog *SaveDialog;
    TPanel *Panel1;
    TShellTreeView *TreeView;
    TSplitter *Splitter1;
    TSplitter *Splitter2;
    TListView *WAVList;
    TMainMenu *MainMenu;
    TMenuItem *iFile;
    TMenuItem *iExit;
    TControlBar *ControlBar1;
    TToolBar *ToolBar1;
    TStatusBar *StatusBar;
    TImageList *ImageList1;
    TToolButton *DelItemsBtn;
    TImageList *ImageList2;
    TMenuItem *iEdit;
    TMenuItem *iSelectAll;
    TMenuItem *iDel;
    TMenuItem *iCopy;
    TToolButton *CopyBtn;
    TMenuItem *iView;
    TMenuItem *iLargeIcons;
    TMenuItem *iSmallIcons;
    TMenuItem *iList;
    TMenuItem *N1;
    TMenuItem *iConvert;
    TMenuItem *iClearList;
    TToolButton *ConvertBtn;
    TLabel *Label1;
    TToolButton *ToolButton2;
    TComboBox *VoxSamplerate;
    TToolButton *PlayBtn;
    TMenuItem *iPlay;
    TMenuItem *N2;
    TShellListView *FileList;
    TToolBar *ToolBar2;
    TShellComboBox *ShellComboBox1;
    TMenuItem *N3;
    TMenuItem *iAbout;
    TToolButton *ToolButton1;
    TLabel *Label2;
    TComboBox *FileType;
    TToolButton *BackBtn;
    TToolButton *RefreshBtn;
    TMenuItem *N4;
    TMenuItem *iRefresh;
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
    void __fastcall iExitClick(TObject *Sender);
    void __fastcall FileListAddFolder(TObject *Sender,
          TShellFolder *AFolder, bool &CanAdd);
    void __fastcall WAVListDragOver(TObject *Sender, TObject *Source,
          int X, int Y, TDragState State, bool &Accept);
    void __fastcall WAVListDragDrop(TObject *Sender, TObject *Source,
          int X, int Y);
    void __fastcall DelItemsBtnClick(TObject *Sender);
    void __fastcall WAVListSelectItem(TObject *Sender, TListItem *Item,
          bool Selected);
    void __fastcall WAVListInsert(TObject *Sender, TListItem *Item);
    void __fastcall iSelectAllClick(TObject *Sender);
    void __fastcall iDelClick(TObject *Sender);
    void __fastcall iCopyClick(TObject *Sender);
    void __fastcall CopyBtnClick(TObject *Sender);
    void __fastcall FileListClick(TObject *Sender);
    void __fastcall FileListKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FileListKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FileListMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall iLargeIconsClick(TObject *Sender);
    void __fastcall iSmallIconsClick(TObject *Sender);
    void __fastcall iListClick(TObject *Sender);
    void __fastcall FileListDblClick(TObject *Sender);
    void __fastcall WAVListDblClick(TObject *Sender);
    void __fastcall iConvertClick(TObject *Sender);
    void __fastcall WAVListDeletion(TObject *Sender, TListItem *Item);
    void __fastcall iClearListClick(TObject *Sender);
    void __fastcall ConvertBtnClick(TObject *Sender);
    void __fastcall PlayBtnClick(TObject *Sender);
    void __fastcall iPlayClick(TObject *Sender);
    void __fastcall iAboutClick(TObject *Sender);
    void __fastcall WAVListKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall BackBtnClick(TObject *Sender);
    void __fastcall RefreshBtnClick(TObject *Sender);
    void __fastcall iRefreshClick(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall FormShow(TObject *Sender);
private:	// User declarations
    TIniFile *IniFile;
    void __fastcall WMDropFiles(TMessage Message);
    void __fastcall AddFile(LPTSTR FileName);
    void __fastcall UpdateFileCount(int Count);
    void __fastcall FindFiles(AnsiString FolderName);
public:		// User declarations
    __fastcall TMainForm(TComponent* Owner);
    BEGIN_MESSAGE_MAP
        VCL_MESSAGE_HANDLER(WM_DROPFILES, TMessage, WMDropFiles)
    END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
