//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TPlayWavDlg.h"
#include "Vox.h"
#include "Main.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TPlayWavDlg *PlayWavDlg;
//---------------------------------------------------------------------
__fastcall TPlayWavDlg::TPlayWavDlg(TComponent* AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------
void __fastcall TPlayWavDlg::FormShow(TObject *Sender)
{
    try
    {
        Player->Open();
        Player->Play();
        Player->TimeFormat = tfMilliseconds;
        PosBar->Position = 0;
        PosBar->Max = Player->Length / 10;
        PosBar->Frequency = Player->Length / 200;
        if (!PosBar->Frequency) PosBar->Frequency = 1;
        Timer->Enabled = true;
        PosBar->Enabled = true;
        SendMessage(Player->Handle, WM_LBUTTONDOWN, 0, 0);
        SendMessage(Player->Handle, WM_LBUTTONUP, 0, 0);
    }
    catch (Exception &e)
    {
        Application->MessageBox("   .\n,    ,\n   .", "",
            MB_OK | MB_ICONEXCLAMATION);
        PostMessage(Handle, WM_CLOSE, 0, 0);
        return;
    }
    DWORD l = Player->Length;
    char buf[32];
    wsprintf(buf, "%02d:%02d:%02d.%03d",
        l / 86400000, (l % 86400000) / 60000, (l % 60000) / 1000, l % 1000);
    EndTime->Caption = buf;
}
//---------------------------------------------------------------------------
void __fastcall TPlayWavDlg::TimerTimer(TObject *Sender)
{
    PosBar->OnChange = NULL;
    PosBar->Position = Player->Position / 10;
    if (Player->Position == Player->Length) Close();
    PosBar->OnChange = PosBarChange;
}
//---------------------------------------------------------------------------
void __fastcall TPlayWavDlg::FormClose(TObject *Sender,
      TCloseAction &Action)
{
    Timer->Enabled = false;
    PosBar->Enabled = false;
    if (!Player->Error)
    {
        Player->Stop();
        Player->Close();
    }
}
//---------------------------------------------------------------------------
void __fastcall TPlayWavDlg::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if (Key == VK_ESCAPE) Close();
}
//---------------------------------------------------------------------------
void __fastcall TPlayWavDlg::Button1Click(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TPlayWavDlg::PlayerClick(TObject *Sender,
      TMPBtnType Button, bool &DoDefault)
{
    if (Button == btStop)
        Player->Position = 0;
}
//---------------------------------------------------------------------------
void __fastcall TPlayWavDlg::PosBarChange(TObject *Sender)
{
    Timer->Enabled = false;
    Player->Position = PosBar->Position * 10;
    Timer->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TPlayWavDlg::Play(AnsiString FileName)
{
    this->FileName->Caption = FileName;
    bool IsVox =
        ((MainForm->FileType->ItemIndex == 2) ||
        (ExtractFileExt(FileName).LowerCase() == ".vox")) &&
        !(MainForm->FileType->ItemIndex == 1);
    char TempFileName[MAX_PATH];
    if (IsVox)
    {
        GetTempPath(MAX_PATH, TempFileName);
        GetTempFileName(TempFileName, "wav", 0, TempFileName);
        DeleteFile(TempFileName);
        char *dot = strchr(TempFileName, '.');
        if (dot) *dot = 0;
        lstrcat(TempFileName, ".wav");
        VoxToPCM(FileName.c_str(), TempFileName,
            MainForm->VoxSamplerate->Items->Strings[
            MainForm->VoxSamplerate->ItemIndex].ToInt());
        Player->FileName = TempFileName;
    }
    else
        Player->FileName = FileName;
    ShowModal();
    if (IsVox) DeleteFile(TempFileName);
}
//---------------------------------------------------------------------------

